#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <string.h>
#include <stdlib.h>
#define MAX_LEN 20
#define LETTER_WIDTH 6

char text1[MAX_LEN] = "PM FAIR";
int textLen1 = 7;

char text2[MAX_LEN] = "2017";
int textLen2 = 7;
int space;

const int letters[38][6] = 
{   { 0x3f, 0x48, 0x48, 0x48, 0x3f, 0x00  },// A
	{ 0x7f, 0x49, 0x49, 0x49, 0x36, 0x00  },//B
	{ 0x3e, 0x41, 0x41, 0x41, 0x22, 0x00  },//C
	{ 0x7f, 0x41, 0x41, 0x41, 0x3e, 0x00  },//D
	{ 0x7f, 0x49, 0x49, 0x49, 0x41, 0x00  },//E
	{ 0x7f, 0x48, 0x48, 0x48, 0x40, 0x00  },//F
	{ 0x3e, 0x41, 0x41, 0x49, 0x2e, 0x00  },//G
	{ 0x7f, 0x08, 0x08, 0x08, 0x7f, 0x00  },//H
	{ 0x00, 0x00, 0x7f, 0x00, 0x00, 0x00  },//I
	{ 0x06, 0x01, 0x01, 0x01, 0x7e, 0x00  },//J
	{ 0x7f, 0x08, 0x14, 0x22, 0x41, 0x00  },//K
	{ 0x7f, 0x01, 0x01, 0x01, 0x01, 0x00  },//L
	{ 0x7f, 0x20, 0x18, 0x20, 0x7f, 0x00  },//M
	{ 0x7f, 0x10, 0x08, 0x04, 0x7f, 0x00  },//N
	{ 0x3e, 0x41, 0x41, 0x41, 0x3e, 0x00  },//O
	{ 0x7f, 0x48, 0x48, 0x48, 0x30, 0x00  },//P
	{ 0x3f, 0x41, 0x41, 0x43, 0x3f, 0x00  },//Q
	{ 0x7f, 0x48, 0x4c, 0x4a, 0x31, 0x00  },//R
	{ 0x32, 0x49, 0x49, 0x49, 0x26, 0x00  },//S
	{ 0x40, 0x40, 0x7f, 0x40, 0x40, 0x00  },//T
	{ 0x7e, 0x01, 0x01, 0x01, 0x7e, 0x00  },//U
	{ 0x70, 0x0e, 0x01, 0x0e, 0x70, 0x00  },//V
	{ 0x7f, 0x02, 0x0c, 0x02, 0x7f, 0x00  },//W
	{ 0x63, 0x14, 0x08, 0x14, 0x63, 0x00  },//X
	{ 0x60, 0x10, 0x0f, 0x10, 0x60, 0x00  },//Y
	{ 0x43, 0x45, 0x49, 0x51, 0x61, 0x00  },//Z
	{ 0x3e, 0x41, 0x41, 0x41, 0x3e, 0x00  },  // 0 
	{ 0x00, 0x21, 0x7f, 0x01, 0x00, 0x00  }, // 1 
	{ 0x21, 0x43, 0x45, 0x49, 0x31, 0x00  }, // 2 
	{ 0x42, 0x41, 0x51, 0x69, 0x46, 0x00  }, // 3
	{ 0x0c, 0x14, 0x24, 0x5f, 0x04, 0x00  }, // 4
	{ 0x72, 0x51, 0x51, 0x51, 0x4e, 0x00  }, // 5
	{ 0x1e, 0x29, 0x49, 0x49, 0x06, 0x00  }, // 6
	{ 0x40, 0x47, 0x48, 0x50, 0x60, 0x00  }, // 7
	{ 0x36, 0x49, 0x49, 0x49, 0x36, 0x00  }, // 8
	{ 0x30, 0x49, 0x49, 0x4a, 0x3c, 0x00  }, // 9
	{ 0x00, 0x36, 0x36, 0x00, 0x00, 0x00  }, // :
	{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00  },// space
};

volatile unsigned char textArray1[512];
volatile unsigned int arr_len1 = 0;
volatile unsigned int arrIx1 = 0;

volatile unsigned char textArray2[512];
volatile unsigned int arr_len2 = 0;
volatile unsigned int arrIx2 = 0;

void build_text();
void Display();
void init_timer();

int main(){
	PORTD |= (1<<PD0);
	DDRD |= (1<<PD0);
	
	PORTD &=~(1<<PD1);
	DDRD &= ~(1<<PD1);
	
	sei();
	arrIx1 = 0;
	arr_len1 = 0;
	DDRA = 255;
	build_text();
	init_timer();
	while(1){
	}
	return 0;
}

void build_text(void){
	unsigned int i, j;
	for(i = 0; i < textLen1; i++){
		for(j = 0; j < LETTER_WIDTH ; j++){
			if (text1[i] - '0' <= 9 && text1[i] - '0' >= 0) {
				textArray1[arr_len1] = letters[text1[i] - '0'][j];
				arr_len1 = arr_len1 + 1;
			} else
			if (text1[i] == ' ') {
				textArray1[arr_len1] = letters[37][j];
				arr_len1 = arr_len1 + 1;
			} else
			if (text1[i] == ':') {
				textArray1[arr_len1] = letters[36][j];
				arr_len1 = arr_len1 + 1;
			} else {
				textArray1[arr_len1] = letters[text1[i] - 'A'][j];
				arr_len1 = arr_len1 + 1;
			}
		}
		
		//adauga spatiu intre litere
		/*
		for(j = 0; j < LETTER_WIDTH ; j++){
			textArray1[arrLen1] = 0;
			arrLen1 = arrLen1 + 1;
		}
		*/
	}
	
	/*
	space = textLen1 * LETTER_WIDTH;
	//adauga spatiu intre cuvinte
	for(i = 0; i < space; i++){
		textArray1[arrLen1] = 0;
		arrLen1 = arrLen1 + 1;
	}
	*/
}

void Display(void){
	if(arrIx1 < arr_len1){
		PORTA = textArray1[arrIx1++];
	} else {
		arrIx1 = 0;
	}
}

ISR(SIG_OUTPUT_COMPARE1A){
	Display();
}

void init_timer(){
	// initializeaza timer pentru intreruperi 
	OCR1A = 11;
	TCCR1A = 0;
	TCCR1B = (1<<WGM12)|_BV(CS12) | _BV(CS10);
	TIMSK1 |= _BV(OCIE1A);
}
